%% RBFN approximation construction

istep = istep+1;
rbfrad = (dmax*(Dim*npoints)^(-1/Dim))^2;

rbfs = zeros(npoints,npoints);
for i=1:npoints
    for j=1:npoints
        delta = sum((points(i,:)-points(j,:)).^2);
        rbfs(i,j) = exp( -delta/rbfrad);
    end
end

for i=1:npoints
    rbfs(i,i) = rbfs(i,i) + lambda;
end

global weights
weights = linsolve(rbfs,ptsvals(1:npoints));
clear rbfs

rbfs = zeros(npoints,npoints);

for i=1:npoints
    for j=1:npoints
        delta = sum((points(i,:)-points(j,:)).^2);
        rbfs(i,j) = exp( -delta/rbfrad);
    end
end

%% author: Anicka Kucerova, Czech Technical University in Prague
%% version 0.0.1
%% 25 Mar 2009